## bzrtp 5.2.0

=== CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2010-2019  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

cmake_minimum_required(VERSION 3.1)

# CMP0077 policy is required by Flexisip build. Remove it once the CMake required
# version is higer or equal to 3.13.
if(NOT CMAKE_VERSION VERSION_LESS 3.13)
    cmake_policy(SET CMP0077 NEW)
endif()

project(bzrtp VERSION 5.2.0 LANGUAGES C CXX)

option(ENABLE_SHARED "Build shared library." YES)
option(ENABLE_STATIC "Build static library." YES)
option(ENABLE_ZIDCACHE "Turn on compilation of ZID cache, request sqlite" YES)
option(ENABLE_STRICT "Build with strict compile options." YES)
option(ENABLE_TESTS "Enable compilation of unit tests." NO)
option(ENABLE_DOC "Enable API documentation generation." NO)
option(ENABLE_EXPORTEDKEY_V1_0_RETROCOMPATIBILITY "Enable support for Limev1 with older version of bzrtp(before v1.06)" NO)
option(ENABLE_PACKAGE_SOURCE "Create 'package_source' target for source archive making (CMake >= 3.11)" OFF)
option(ENABLE_GOCLEAR "Enable the possibility to send and receive GoClear" YES)
option(ENABLE_PQCRYPTO "Enable Post Quantum Cryptography key agreements algorithms" NO)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS NO)

if(NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(MSVC_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/include/MSVC")
if(MSVC)
	list(APPEND CMAKE_REQUIRED_INCLUDES ${MSVC_INCLUDE_DIR})
endif()

# Hidden non-cache options:
# * DISABLE_BC_PACKAGE_SEARCH: skip find_package() for every BC package (bctoolbox, ortp, etc.)

include(GNUInstallDirs)
include(CheckLibraryExists)
check_library_exists("m" "sqrt" "" HAVE_SQRT)

if(NOT DISABLE_BC_PACKAGE_SEARCH)
	find_package(bctoolbox 0.0.3 REQUIRED OPTIONAL_COMPONENTS tester CONFIG)
	if (ENABLE_PQCRYPTO)
		find_package(postquantumcryptoengine CONFIG REQUIRED)
	endif()
endif()

if(ENABLE_ZIDCACHE)
	find_package(Sqlite3 REQUIRED)
	# Also check if we have libxml2, as we need it for migration purpose
	find_package(XML2)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/config.h PROPERTIES GENERATED ON)
add_definitions("-DHAVE_CONFIG_H")

bc_init_compilation_flags(STRICT_OPTIONS_CPP STRICT_OPTIONS_C STRICT_OPTIONS_CXX ENABLE_STRICT)
if(CMAKE_VERSION VERSION_LESS 3.1 AND NOT APPLE AND NOT MSVC)
	list(APPEND STRICT_OPTIONS_CXX "-std=c++11")
endif()

set(BZRTP_CPPFLAGS ${BCTOOLBOX_CPPFLAGS})
if(ENABLE_STATIC)
	list(APPEND BZRTP_CPPFLAGS "-DBZRTP_STATIC")
endif()
if(BZRTP_CPPFLAGS)
	list(REMOVE_DUPLICATES BZRTP_CPPFLAGS)
	add_definitions(${BZRTP_CPPFLAGS})
endif()

include_directories(
	include
	${CMAKE_CURRENT_BINARY_DIR}
)

if(MSVC)
	include_directories(${MSVC_INCLUDE_DIR})
endif()

if(ENABLE_ZIDCACHE)
	add_definitions("-DZIDCACHE_ENABLED")
	if(XML2_FOUND)
		add_definitions("-DHAVE_LIBXML2")
	endif()
endif()

if(ENABLE_GOCLEAR)
        add_definitions("-DGOCLEAR_ENABLED")
endif()

if (ENABLE_EXPORTEDKEY_V1_0_RETROCOMPATIBILITY)
	add_definitions("-DSUPPORT_EXPORTEDKEY_V010000")
endif()

if (postquantumcryptoengine_FOUND)
	add_definitions("-DHAVE_BCTBXPQ")
	message(STATUS "Building with Post Quantum Key Agreements")
endif()

set(EXPORT_TARGETS_NAME "bzrtp")

add_subdirectory(include)
add_subdirectory(src)
if(ENABLE_TESTS)
	enable_testing()
	add_subdirectory(test)
endif()


include(CMakePackageConfigHelpers)
set(CONFIG_PACKAGE_LOCATION "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/cmake")

write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGETS_NAME}ConfigVersion.cmake"
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)

if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
	export(EXPORT ${EXPORT_TARGETS_NAME}Targets
		FILE "${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGETS_NAME}Targets.cmake"
	)
endif()

configure_package_config_file(cmake/BZRTPConfig.cmake.in
	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGETS_NAME}Config.cmake"
	INSTALL_DESTINATION ${CONFIG_PACKAGE_LOCATION}
	NO_SET_AND_CHECK_MACRO
)

install(EXPORT ${EXPORT_TARGETS_NAME}Targets
	FILE ${EXPORT_TARGETS_NAME}Targets.cmake
	DESTINATION ${CONFIG_PACKAGE_LOCATION}
)
install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGETS_NAME}Config.cmake"
	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGETS_NAME}ConfigVersion.cmake"
	DESTINATION ${CONFIG_PACKAGE_LOCATION}
)

if(ENABLE_DOC)
	# Doxygen
	find_package(Doxygen)
	if (DOXYGEN_FOUND)
		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
		add_custom_target(doc ALL
			${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			COMMENT "Generating API documentation with Doxygen" VERBATIM)
		install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/doc/html/"
			DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/bzrtp-${PROJECT_VERSION}")
	endif()
endif()

if (ENABLE_PACKAGE_SOURCE)
	add_subdirectory(build)
endif()

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(BZRTP_C_SOURCE_FILES
	bzrtp.c
	packetParser.c
	pgpwords.c
	stateMachine.c
	zidCache.c
)
set(BZRTP_CXX_SOURCE_FILES
	cryptoUtils.cc
)

add_definitions(
	-DBCTBX_LOG_DOMAIN="bzrtp"
)


bc_apply_compile_flags(BZRTP_C_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(BZRTP_CPP_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

set(BZRTP_SOURCE_FILES ${BZRTP_C_SOURCE_FILES} ${BZRTP_CXX_SOURCE_FILES})
set(INCLUDE_DIRS )
set(LIBS )

if(SQLITE3_FOUND)
	list(APPEND INCLUDE_DIRS ${SQLITE3_INCLUDE_DIRS})
	list(APPEND LIBS $<BUILD_INTERFACE:${SQLITE3_LIBRARIES}> $<INSTALL_INTERFACE:${SQLITE3_LIBRARIES}>)
endif()

if(XML2_FOUND)
	list(APPEND INCLUDE_DIRS ${XML2_INCLUDE_DIRS})
	list(APPEND LIBS $<BUILD_INTERFACE:${XML2_LIBRARIES}>  $<INSTALL_INTERFACE:${XML2_LIBRARIES}>)
endif()

if(ENABLE_STATIC)
	add_library(bzrtp STATIC ${BZRTP_SOURCE_FILES})
	set_target_properties(bzrtp PROPERTIES OUTPUT_NAME bzrtp)
	target_include_directories(bzrtp INTERFACE
		$<INSTALL_INTERFACE:include>
		PRIVATE ${INCLUDE_DIRS})
	target_link_libraries(bzrtp PRIVATE bctoolbox ${LIBS})
	if (postquantumcryptoengine_FOUND)
		target_link_libraries(bzrtp PRIVATE postquantumcryptoengine)
	endif()
	install(TARGETS bzrtp EXPORT ${EXPORT_TARGETS_NAME}Targets
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()
if(ENABLE_SHARED)
	add_library(bzrtp SHARED ${BZRTP_SOURCE_FILES})
	target_compile_definitions(bzrtp PRIVATE "-DBZRTP_EXPORTS")
	set_target_properties(bzrtp PROPERTIES VERSION 0)
	target_include_directories(bzrtp PUBLIC
		$<INSTALL_INTERFACE:include>
		$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
		PRIVATE ${INCLUDE_DIRS}
	)
	target_link_libraries(bzrtp PRIVATE bctoolbox ${LIBS})
	if (postquantumcryptoengine_FOUND)
		target_link_libraries(bzrtp PRIVATE postquantumcryptoengine)
	endif()
	if(MSVC)
		if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
			install(FILES $<TARGET_PDB_FILE:bzrtp>
				DESTINATION ${CMAKE_INSTALL_BINDIR}
				PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
			)
		endif()
	endif()
	install(TARGETS bzrtp EXPORT ${EXPORT_TARGETS_NAME}Targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

=== test/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(BZRTP_TEST_C_SOURCES
	bzrtpParserTest.c
	bzrtpConfigsTest.c
	bzrtpZidCacheTest.c
	bzrtpTest.c
	testUtils.c
)
set(BZRTP_TEST_CXX_SOURCES
	bzrtpCryptoTest.cc
)

add_definitions(
	-DBCTBX_LOG_DOMAIN="bzrtp"
)

bc_apply_compile_flags(BZRTP_TEST_C_SOURCES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(BZRTP_TEST_CXX_SOURCES STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

add_executable(bzrtpTest ${BZRTP_TEST_C_SOURCES} ${BZRTP_TEST_CXX_SOURCES})
set_target_properties(bzrtpTest PROPERTIES LINK_FLAGS "${LINK_FLAGS}")
set_target_properties(bzrtpTest PROPERTIES LINKER_LANGUAGE CXX)

target_link_libraries(bzrtpTest PRIVATE bctoolbox bctoolbox-tester)

if(ENABLE_STATIC)
	target_link_libraries(bzrtpTest PRIVATE bzrtp)
else()
	target_link_libraries(bzrtpTest PRIVATE bzrtp)
endif()
if(SQLITE3_FOUND)
	target_include_directories(bzrtpTest PRIVATE ${SQLITE3_INCLUDE_DIRS})
	target_link_libraries(bzrtpTest PRIVATE ${SQLITE3_LIBRARIES})
endif()
if(XML2_FOUND)
  	target_include_directories(bzrtpTest PRIVATE ${XML2_INCLUDE_DIRS})
	target_link_libraries(bzrtpTest PRIVATE ${XML2_LIBRARIES})
endif()

if(HAVE_SQRT)
	target_link_libraries(bzrtpTest PRIVATE m)
endif()

unset(PATTERN_FILES_IN_TEST_DIR CACHE)
find_file(PATTERN_FILES_IN_TEST_DIR
       patternZIDAlice.sqlite ${CMAKE_CURRENT_BINARY_DIR}
)
if (NOT PATTERN_FILES_IN_TEST_DIR)
       file(COPY patternZIDAlice.sqlite DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
endif()

add_test(NAME bzrtpTest COMMAND bzrtpTest --resource-dir .)

=== debian/changelog ===
bzrtp (5.2.0-2ubuntu4) noble; urgency=medium

  * No-change rebuild against libbctoolbox1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 09 Apr 2024 02:09:26 +0000

bzrtp (5.2.0-2ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:45:05 +0000

bzrtp (5.2.0-2ubuntu2) noble; urgency=medium

  * No-change rebuild against libbctoolbox1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 03:00:37 +0000

bzrtp (5.2.0-2ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build on ppc64el by lowering optimization level to -O2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 29 Jul 2023 21:52:50 +0200

bzrtp (5.2.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Fri, 28 Jul 2023 22:46:06 +0200

bzrtp (5.2.0-1) experimental; urgency=medium

  * New upstream release 5.2.0.
  * Codebase is now partially C++11 (ABI break, thus SOVERSION bumped to 1).
  * Replace the .symbols file with a .shlibs file for simplicity.
  * Comply with Debian policy v4.6.2.

 -- Dennis Filder <d.filder@web.de>  Mon, 19 Dec 2022 18:37:02 +0100

bzrtp (5.1.64-2ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build on ppc64el by lowering optimization level to -O2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 28 Nov 2022 14:22:06 +0100

bzrtp (5.0.37-2ubuntu1) lunar; urgency=medium

  * Fix build on ppc64el by lowering optimization level to -O2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Nov 2022 09:11:18 +0100

=== debian/control ===
Source: bzrtp
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Kilian Krause <kilian@debian.org>,
           Tzafrir Cohen <tzafrir@debian.org>,
           Bernhard Schmidt <berni@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               libbctoolbox-dev (>= 5.2.0~),
               libsqlite3-dev,
               libxml2-dev,
Standards-Version: 4.6.2
Section: libs
Rules-Requires-Root: no
Homepage: https://www.linphone.org/
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/bzrtp.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/bzrtp
Description: Library for the ZRTP key exchange protocol

Package: libbzrtp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libbzrtp1 (= ${binary:Version}),
         libbctoolbox-dev (>= 5.2.0~),
         libxml2-dev,
         ${misc:Depends},
Description: Development files for the Bzrtp key exchange library
 Bzrtp is an open source implementation of the ZRTP key exchange protocol.
 The library is written in C and C++. It is fully portable and can be executed
 on many platforms including ARM and x86.
 .
 This package contains the development files.

Package: libbzrtp1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Library for the ZRTP key exchange protocol
 Bzrtp is an open source implementation of the ZRTP key exchange protocol.
 The library is written in C and C++. It is fully portable and can be executed
 on many platforms including ARM and x86.
 .
 The library enables encrypted communications in Linphone.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_HOST_ARCH),ppc64el)
  export DEB_CFLAGS_MAINT_APPEND = -O2
endif

%:
	dh $@ --buildsystem=cmake

# Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
# setting CMAKE_SKIP_RPATH
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DENABLE_STATIC=no \
		-DDEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM)

execute_after_dh_auto_install:
	echo 'Requires.private: bctoolbox >= $(DEB_VERSION_UPSTREAM)' \
		>> debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libbzrtp.pc

# For fallback BC sometimes offers autoconf build systems.  As we
# don't use it we don't want it updated, otherwise dpkg-source nags.
override_dh_autotools_update_config:
override_dh_autoreconf:

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/bzrtp.*\.tar\.gz/bzrtp-$1\.tar\.gz/g \
  https://gitlab.linphone.org/BC/public/bzrtp/tags?sort=updated_desc .*/archive/([\d\.]+)/.*\.tar\.gz.*

## bzrtp 5.3.105

=== CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2010-2023  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

cmake_minimum_required(VERSION 3.22)

project(BZRTP VERSION 5.3.0 LANGUAGES C CXX)

option(ENABLE_ZIDCACHE "Turn on compilation of ZID cache, request sqlite" YES)
option(ENABLE_STRICT "Build with strict compile options." YES)
option(ENABLE_UNIT_TESTS "Enable compilation of unit tests." NO)
option(ENABLE_DOC "Enable API documentation generation." NO)
option(ENABLE_PACKAGE_SOURCE "Create 'package_source' target for source archive making" OFF)
option(ENABLE_GOCLEAR "Enable the possibility to send and receive GoClear" YES)
option(ENABLE_PQCRYPTO "Enable Post Quantum Cryptography key agreements algorithms" NO)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS NO)

if(NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
include(CheckLibraryExists)
check_library_exists("m" "sqrt" "" HAVE_SQRT)

find_package(BCToolbox 5.3.0 REQUIRED OPTIONAL_COMPONENTS tester)
if(ENABLE_PQCRYPTO)
	find_package(PostQuantumCryptoEngine 5.3.0 REQUIRED)
endif()
if(ENABLE_ZIDCACHE)
	bc_find_package(SQLite3 SQLite::SQLite3 sqlite3 REQUIRED)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/config.h PROPERTIES GENERATED ON)
add_definitions("-DHAVE_CONFIG_H")

bc_init_compilation_flags(STRICT_OPTIONS_CPP STRICT_OPTIONS_C STRICT_OPTIONS_CXX ENABLE_STRICT)

set(BZRTP_CPPFLAGS ${BCTOOLBOX_CPPFLAGS})
if(NOT BUILD_SHARED_LIBS)
	list(APPEND BZRTP_CPPFLAGS "-DBZRTP_STATIC")
endif()
if(BZRTP_CPPFLAGS)
	list(REMOVE_DUPLICATES BZRTP_CPPFLAGS)
	add_definitions(${BZRTP_CPPFLAGS})
endif()

include_directories(
	include
	${CMAKE_CURRENT_BINARY_DIR}
)

if(ENABLE_ZIDCACHE)
	add_definitions("-DZIDCACHE_ENABLED")
endif()

if(ENABLE_GOCLEAR)
        add_definitions("-DGOCLEAR_ENABLED")
endif()

if(ENABLE_PQCRYPTO)
	add_definitions("-DHAVE_BCTBXPQ")
	message(STATUS "Building with Post Quantum Key Agreements")
endif()

add_subdirectory(include)
add_subdirectory(src)
if(ENABLE_UNIT_TESTS AND NOT ANDROID AND NOT IOS)
	enable_testing()
	add_subdirectory(test)
endif()

if(ENABLE_DOC)
	# Doxygen
	find_package(Doxygen)
	if (DOXYGEN_FOUND)
		set(DOXYGEN_INPUT "")
		file(GLOB DOC_INPUT_FILES
			"${PROJECT_SOURCE_DIR}/include/[^.]*.h"
			"${PROJECT_SOURCE_DIR}/src/[^.]*.c"
			"${PROJECT_SOURCE_DIR}/src/[^.]*.cc"
		)
		foreach (INPUT_FILE ${DOC_INPUT_FILES})
			string(CONCAT DOXYGEN_INPUT ${DOXYGEN_INPUT} " \"${INPUT_FILE}\"")
		endforeach ()
		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
		add_custom_command(OUTPUT "${PROJECT_BINARY_DIR}/doc/html/index.html"
			COMMAND "${DOXYGEN_EXECUTABLE}" "${PROJECT_BINARY_DIR}/Doxyfile"
			DEPENDS "${PROJECT_BINARY_DIR}/Doxyfile" ${DOC_INPUT_FILES}
		)
		add_custom_target(bzrtp-doc ALL
			DEPENDS "${PROJECT_BINARY_DIR}/doc/html/index.html"
			COMMENT "Generating API documentation with Doxygen" VERBATIM
		)
		install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/doc/html/"
			DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/bzrtp-${PROJECT_VERSION}")
	endif()
endif()

if(ENABLE_PACKAGE_SOURCE)
	add_subdirectory(build)
endif()

include(CMakePackageConfigHelpers)
set(CMAKE_MODULES_INSTALL_DIR "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/cmake")
configure_package_config_file("cmake/${PROJECT_NAME}Config.cmake.in" "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
	INSTALL_DESTINATION "${CMAKE_MODULES_INSTALL_DIR}"
	NO_SET_AND_CHECK_MACRO
)
write_basic_package_version_file("${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)
install(FILES
	"${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
	"${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
	DESTINATION ${CMAKE_MODULES_INSTALL_DIR}
)
if(ENABLE_PQCRYPTO)
	install(FILES "cmake/FindPostQuantumCryptoEngine.cmake" DESTINATION ${CMAKE_MODULES_INSTALL_DIR})
endif()

install(EXPORT ${PROJECT_NAME}Targets
	FILE "${PROJECT_NAME}Targets.cmake"
	DESTINATION ${CMAKE_MODULES_INSTALL_DIR}
)

=== build/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2010-2023  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

if(NOT CPACK_PACKAGE_NAME)
	set(CPACK_PACKAGE_NAME "bzrtp")
ENDIF()

set(CPACK_SOURCE_IGNORE_FILES
	"${CMAKE_BINARY_DIR}"
	"^${PROJECT_SOURCE_DIR}/.git*"
)

bc_make_package_source_target()

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014-2023  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(BZRTP_C_SOURCE_FILES
	bzrtp.c
	packetParser.c
	pgpwords.c
	stateMachine.c
	zidCache.c
)
set(BZRTP_CXX_SOURCE_FILES
	cryptoUtils.cc
)

add_definitions(
	-DBCTBX_LOG_DOMAIN="bzrtp"
)


bc_apply_compile_flags(BZRTP_C_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(BZRTP_CPP_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

set(BZRTP_SOURCE_FILES ${BZRTP_C_SOURCE_FILES} ${BZRTP_CXX_SOURCE_FILES})

add_library(bzrtp ${BZRTP_SOURCE_FILES})
set_target_properties(bzrtp PROPERTIES VERSION 0)
target_include_directories(bzrtp PUBLIC
	$<INSTALL_INTERFACE:include>
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
)
target_link_libraries(bzrtp PRIVATE ${BCToolbox_TARGET})
if(SQLite3_FOUND)
	target_link_libraries(bzrtp PUBLIC ${SQLite3_TARGET})
endif()
if(ENABLE_PQCRYPTO)
	target_link_libraries(bzrtp PRIVATE ${PostQuantumCryptoEngine_TARGET})
endif()

if(BUILD_SHARED_LIBS)
	target_compile_definitions(bzrtp PRIVATE "-DBZRTP_EXPORTS")
	if(MSVC)
		install(FILES $<TARGET_PDB_FILE:bzrtp>
			DESTINATION ${CMAKE_INSTALL_BINDIR}
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
			CONFIGURATIONS Debug RelWithDebInfo
		)
	endif()
endif()

install(TARGETS bzrtp EXPORT ${PROJECT_NAME}Targets
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== test/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014-2023  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(BZRTP_TEST_C_SOURCES
	bzrtpParserTest.c
	bzrtpConfigsTest.c
	bzrtpZidCacheTest.c
	bzrtpTest.c
	testUtils.c
)
set(BZRTP_TEST_CXX_SOURCES
	bzrtpCryptoTest.cc
)

add_definitions(
	-DBCTBX_LOG_DOMAIN="bzrtp"
)

bc_apply_compile_flags(BZRTP_TEST_C_SOURCES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(BZRTP_TEST_CXX_SOURCES STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

add_executable(bzrtp-tester ${BZRTP_TEST_C_SOURCES} ${BZRTP_TEST_CXX_SOURCES})
set_target_properties(bzrtp-tester PROPERTIES LINKER_LANGUAGE CXX)
target_link_libraries(bzrtp-tester PRIVATE ${BCToolbox_tester_TARGET} bzrtp)
if(HAVE_SQRT AND NOT WIN32)
	target_link_libraries(bzrtp-tester PRIVATE m)
endif()

install(TARGETS bzrtp-tester
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)
install(FILES patternZIDAlice.sqlite DESTINATION "${CMAKE_INSTALL_DATADIR}/bzrtp-tester")

=== debian/changelog ===
bzrtp (5.3.105-1ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build on amd64 and ppc64el by lowering optimization level to -O2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 04 Mar 2025 13:45:11 +0100

bzrtp (5.3.105-1) unstable; urgency=medium

  * New upstream version 5.3.105

 -- Victor Seva <vseva@debian.org>  Sun, 23 Feb 2025 00:26:09 +0100

bzrtp (5.3.104-1ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix build on ppc64el by lowering optimization level to -O2
  * New Changes:
    - Fix build by lowering optimization level to -O2 on all arch.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 12 Feb 2025 12:37:42 +0000

bzrtp (5.3.104-1) unstable; urgency=medium

  * add myself to Uploaders. wrap-and-sort -sat
  * Set upstream metadata fields: Repository-Browse.
  * New upstream version 5.3.104
  * update stack dependencies (Closes: #1094083)
  * debian/copyright: update
  * remove empty patches/to_upstream
  * refresh debian/patches
  * update Breaks with versions in trixie and bookworm

 -- Victor Seva <vseva@debian.org>  Fri, 07 Feb 2025 10:25:57 +0100

bzrtp (5.2.98-2) experimental; urgency=medium

  * Express Breaks on libmediastreamer13 which still link with
    libbctoolbox1.

 -- Dennis Filder <d.filder@web.de>  Thu, 12 Oct 2023 18:05:45 +0200

bzrtp (5.2.98-1) experimental; urgency=medium

  * New upstream release 5.2.98.
  * Tighten build-dep on bctoolbox to 5.2.98.

 -- Dennis Filder <d.filder@web.de>  Sat, 02 Sep 2023 14:33:42 +0200

=== debian/control ===
Source: bzrtp
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Kilian Krause <kilian@debian.org>,
 Tzafrir Cohen <tzafrir@debian.org>,
 Bernhard Schmidt <berni@debian.org>,
 Victor Seva <vseva@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libbctoolbox-dev (>= 5.3.104~),
 libsqlite3-dev,
 libxml2-dev,
Standards-Version: 4.6.2
Section: libs
Rules-Requires-Root: no
Homepage: https://www.linphone.org/
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/bzrtp.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/bzrtp
Description: Library for the ZRTP key exchange protocol

Package: libbzrtp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libbctoolbox-dev (>= 5.3.104~),
 libbzrtp1 (= ${binary:Version}),
 libxml2-dev,
 ${misc:Depends},
Description: Development files for the Bzrtp key exchange library
 Bzrtp is an open source implementation of the ZRTP key exchange protocol.
 The library is written in C and C++. It is fully portable and can be executed
 on many platforms including ARM and x86.
 .
 This package contains the development files.

Package: libbzrtp1
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libmediastreamer12 (<< 1:5.3.104~),
 libmediastreamer13t64 (<< 1:5.3.104~),
Description: Library for the ZRTP key exchange protocol
 Bzrtp is an open source implementation of the ZRTP key exchange protocol.
 The library is written in C and C++. It is fully portable and can be executed
 on many platforms including ARM and x86.
 .
 The library enables encrypted communications in Linphone.

=== debian/rules ===
--- 
+++ 
@@ -11,13 +11,17 @@
   export DEB_CFLAGS_MAINT_APPEND = -O2
 endif
 
+ifeq ($(DEB_HOST_ARCH),amd64)
+  export DEB_CFLAGS_MAINT_APPEND = -O2
+endif
+
 %:
 	dh $@ --buildsystem=cmake
 
 # Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
 # setting CMAKE_SKIP_RPATH
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DENABLE_STATIC=no \
+	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DBUILD_SHARED_LIBS=ON \
 		-DDEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM)
 
 execute_after_dh_auto_install:
